<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="companyId"
          :columns="columns"
          :datasource="datasource"
          v-model:selection="selection"
          :customRow="customRow"
          tool-class="ele-toolbar-form"
          :scroll="{ x: 800 }"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'companyName'">
              <a-avatar
                :size="30"
                :src="`${FILE_THUMBNAIL + record.companyLogo}`"
                style="margin-right: 4px"
                :srcset="`${FILE_THUMBNAIL + record.companyLogo}`"
              >
                <template #icon>
                  <UserOutlined />
                </template>
              </a-avatar>
              <a-tooltip title="查看详情">
                <a href="#" @click="openEdit(record)">{{
                  record.companyName
                }}</a>
              </a-tooltip>
            </template>
            <template v-if="column.key === 'companyTypeMultiple'">
              <a-tag
                v-for="(d, i) in JSON.parse(record.companyTypeMultiple)"
                :key="i"
              >
                <span>{{ d }}</span>
              </a-tag>
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">正常</a-tag>
              <a-tag v-if="record.status === 1" color="red">待审核</a-tag>
              <a-tag v-if="record.status === 2" color="purple">已驳回</a-tag>
            </template>
            <template v-if="column.key === 'nickname'">
              <a-tooltip :title="`${record.nickname}`">
                <a-avatar :src="record.userAvatar" size="small" />
              </a-tooltip>
            </template>
            <template v-if="column.key === 'isTax'">
              <a-tag v-if="record.isTax">是</a-tag>
              <a-tag v-else>否</a-tag>
            </template>
            <template v-if="column.key === 'createTime'">
              <a-tooltip :title="`${toDateString(record.createTime)}`">
                {{ timeAgo(record.createTime) }}
              </a-tooltip>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openEdit(record)">修改</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <CompanyEdit v-model:visible="showEdit" :data="current" @done="reload" />
      <!-- 企业详情弹窗 -->
      <CompanyInfo v-model:visible="showInfo" :data="current" @done="reload" />
      <!-- 批量转移弹窗 -->
      <!--    <CompanyMove v-model:visible="showMove" :data="selection" @done="batchMove" />-->
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { computed, createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import {
    ExclamationCircleOutlined,
    UserOutlined
  } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import { toDateString } from 'ele-admin-pro';
  import Search from './components/search.vue';
  import CompanyEdit from './components/company-edit.vue';
  import CompanyInfo from './components/company-info.vue';
  import {
    pageCompany,
    removeCompany,
    removeBatchCompany
  } from '@/api/system/company';
  import { timeAgo } from 'ele-admin-pro';
  import type { Company, CompanyParam } from '@/api/system/company/model';
  import { useUserStore } from '@/store/modules/user';
  import { FILE_THUMBNAIL } from '@/config/setting';

  const userStore = useUserStore();

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<Company[]>([]);
  // 当前编辑数据
  const current = ref<Company | null>(null);

  // 是否显示资产详情
  const showInfo = ref(false);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.progress = filters.progress;
      where.companySource = filters.companySource;
      where.companyType = filters.companyType;
      where.status = filters.status;
    }
    return pageCompany({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      key: 'index',
      width: 48,
      align: 'center',
      fixed: 'left',
      hideInSetting: true,
      customRender: ({ index }) => index + (tableRef.value?.tableIndex ?? 0)
    },
    {
      title: '企业名称',
      dataIndex: 'companyName',
      key: 'companyName'
    },
    {
      title: '企业类型',
      dataIndex: 'companyTypeMultiple',
      key: 'companyTypeMultiple'
    },
    {
      title: '企业负责人',
      dataIndex: 'businessEntity'
    },
    {
      title: '联系电话',
      dataIndex: 'phone'
    },
    {
      title: '是否含税',
      dataIndex: 'isTax',
      key: 'isTax'
    },
    {
      title: '操作',
      key: 'action',
      width: 200,
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: CompanyParam) => {
    console.log(where);
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: Company) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 打开用户详情弹窗 */
  const openInfo = (row?: Company) => {
    current.value = row ?? null;
    showInfo.value = true;
  };

  /* 删除单个 */
  const remove = (row: Company) => {
    const hide = message.loading('请求中..', 0);
    removeCompany(row.companyId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量转移 */
  const batchMove = (userId) => {
    console.log(userId, '批量转移0000');
    console.log(selection.value);
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchCompany(selection.value.map((d) => d.companyId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 自定义行属性 */
  const customRow = (record: Company) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
</script>

<script lang="ts">
  export default {
    name: 'Accessory'
  };
</script>

<style lang="less" scoped>
  .sys-org-table :deep(.ant-table-body) {
    overflow: auto !important;
    overflow: overlay !important;
  }

  .sys-org-table :deep(.ant-table-pagination.ant-pagination) {
    padding: 0 4px;
    margin-bottom: 0;
  }
</style>
